#ifndef FILES_H
  #define FILES_H

#include "tworddata.h"
#include "objects.h"


class BinDataFile
{
     FILE* f;

     void seek(long int pos)
         {
              if(f==NULL) return;
              if(fseek(f,sizeof(vocab_header)+(pos)*sizeof(TWordData),SEEK_SET)!=0) throw errorcl("Seek error in binary index");
              return;
         };
   public:

     BinDataFile() {;};
     BinDataFile(char* fname)
             {
                  f=fopen(fname,"rb");
                  if(f==NULL) throw errorcl("Can't open binary index");
             };
     ~BinDataFile() { if(f!=NULL) fclose(f);};
     void open(char* file){ if(f!=NULL) fclose(f);f=fopen(file,"rb");if(f==NULL) throw errorcl("Can't open binary index");};
     TWordData get(long int pos)
             {
                 seek(pos);
                 TWordData d;
                 if(fread(&d,sizeof(d),1,f)!=1) throw errorcl("Binary index read error");
                 return d;
             };
     void fill(TWordDataList& list, long int pos, long int count)
           {
                 seek(pos);
                 if(list.count!=count) list.resize(count);
                 list.count=fread(list.list,sizeof(TWordData),count,f);
                 if(list.count<1) throw errorcl("List read error from binary index");
                 return;
           };
     void readheader(vocab_header& to)
           {
                fseek(f,0L,SEEK_SET);
                if(fread(&to,sizeof(to),1,f)!=1) throw errorcl("Binary index read error (headder)");
                return;
           };

};


class DataFile
{
     FILE* f;

     void seek(long int pos)
     {
          if(f==NULL) return;
          if(fseek(f,pos,SEEK_SET)!=0) throw errorcl("Seek error in data file");
          return;
     };

   public:

     DataFile() {;};
     DataFile(char* fname)
             {
                  f=fopen(fname,"rb");
                  if(f==NULL) throw errorcl("Can't open data file");
             };
     ~DataFile() { if(f!=NULL) fclose(f);};
     void open(char* file){ if(f!=NULL) fclose(f);f=fopen(file,"rb");if(f==NULL) throw errorcl("Can't open data file");};
     void get(String& s,const TWordData& dat)
             {
                 seek(dat.pos);
                 s.resize(dat.length);
                 if(fread(s.getsamestr(),dat.length,1,f)!=1) throw errorcl("Data file read error");
                 return;
             };
};


class WordFile
{
     FILE* f;

     void seek(long int pos)
         {
              if(f==NULL) return;
              if(fseek(f,pos,SEEK_SET)!=0) throw errorcl("Seek error in word index");
              return;
         };
   public:

     WordFile() {;};
     WordFile(char* fname)
             {
                  f=fopen(fname,"rb");
                  if(f==NULL) throw errorcl("Can't open word index");
             };
     ~WordFile() { if(f!=NULL) fclose(f);};
     void open(char* file){ if(f!=NULL) fclose(f);f=fopen(file,"rb");if(f==NULL) throw errorcl("Can't open word index");};
     void get(String& s,const TWordData& dat)
             {
                 seek(dat.wordpos);
                 s.resize(dat.wordlength);
                 if(fread(s.getsamestr(),dat.wordlength,1,f)!=1) throw errorcl("Word index read error");
                 return;
             };
     void fill(TWordList& list, TWordDataList& data)
            {
                 if(list.count()!=data.count) list.resize(data.count);
                 TWordData* p;
                 for(int i=0;i<data.count;i++)
                 {
                    p=&data[i];
                    get(list[i],data[i]);
                 }
            }

};


#endif
