#ifndef OBJECTS_H
  #define OBJECTS_H


#include "tworddata.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>


class errorcl
{
   public:
     char* what;
     int code;
     errorcl(char* s,int c=0) {what=strdup(s);code=c;};
     ~errorcl() {free(what);};
};

class String {
     char* str;
     long int size;
  public:
     String(char* s) { if(s!=NULL){str=strdup(s);size=strlen(s);};};
     String(String& s) { str=s.getstr();size=s.length();};
     String() {str=NULL;size=0;};
     ~String() {if(str!=NULL) free(str);};
     void resize(long int nsize) {if(str!=NULL) free(str); str=(char*) calloc(nsize+1,sizeof(char));size=nsize;};
     char* getstr() { if(str==NULL) return ""; return strdup(str);};
     char* getsamestr() { return str;};
     long int& length() {return size;};
     char& operator [] (long int pos) {if(pos<size) return str[pos]; return str[size];};
     String& operator = (char* s)
                       {
                           if(s==NULL) return *this;
                           if(str!=NULL) free(str);
                           str=strdup(s);
                           size=strlen(s);
                           return *this;
                       };
     String& operator = (String& s)
                       {

                           if(str!=NULL) free(str);
                           str=s.getstr();
                           size=s.length();
                           return *this;
                       };
     friend int cmp(String& s1, String& s2)
                 {
                      return strcmp(s1.str,s2.str);
                 };

     friend int operator <  (String& s1, String& s2) { return (cmp(s1,s2)<0)?1:0;};
     friend int operator <= (String& s1, String& s2) { return (cmp(s1,s2)<=0)?1:0;};
     friend int operator >  (String& s1, String& s2) { return (cmp(s1,s2)>0)?1:0;};
     friend int operator >= (String& s1, String& s2) { return (cmp(s1,s2)>=0)?1:0;};
     friend int operator == (String& s1, String& s2) { return (cmp(s1,s2)==0)?1:0;};
     friend int numcmp(String& s1, String& s2, int skip1=0, int skip2=0);


};

extern int numcmp(String& s1, String& s2, int skip1, int skip2);


class TWordDataList
{
   public:
      PWordData list;
      long int count;

      TWordDataList(long int size=1)  { list= new TWordData[size]; count=size;};
      ~TWordDataList()  { if(list!=NULL) delete[] list;};
      void resize(long int newsize) {if(list!=NULL) delete[] list; list= new TWordData[newsize]; count=newsize;};
      TWordData& operator [] (long int pos)
          {
              if(pos>=count)
                   throw errorcl("Index out of bounds in TWordDataList");
              return list[pos];
          };
};


class TWordList
{
     String* list;
     long int _count;

   public:

     TWordList(long int size) {list = new String[size]; _count=size;};
     TWordList() {list=NULL; _count=0;};
     ~TWordList() { if(list!=NULL) delete[] list;};
     String& operator [] (long int pos)
          {
               if(pos>=_count) throw errorcl("Index out of bounds in TWordList");
               return list[pos];
          };
     long int count() {return _count;};
     void resize(long int nsize) { if(list!=NULL) delete[] list;
                                   if(nsize>0) list = new String[nsize];
                                   _count=nsize;};
     TWordList& operator = (TWordList& l){ resize(l.count()); for(long int i=0;i<_count;i++) list[i]=l[i]; return *this;};


};


extern int numcmp(String& s1, String& s2, int skip1, int skip2);


#endif
