/* slovar.h */
////////////////////////////////////////////////////
//  ᫮
// vers.0.2
// (c) Nike Korolev, Evgeny Kotsuba 2000-2001
////////////////////////////////////////////////////

#ifndef SLOVAR_H
  #define SLOVAR_H


#define POKA 0

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

////////////////////////////////////////////////////
#define VD_MAXPATH 256
#define VD_SIGNATURE  "VD"

// VD_SIGNATURE_xxx + VD_VERSION + VD_SUBVERSION = 8 bytes
#define VD_SIGNATURE_BDX  VD_SIGNATURE "B"
#define VD_SIGNATURE_WRD  VD_SIGNATURE "W"
#define VD_SIGNATURE_DAT  VD_SIGNATURE "D"

#define VD_VERSION        "002"
#define VD_SUBVERSION     "00"
// bdx-䠩

struct VocHeader
{  char signature[8]; // ᨣp
   int n;        // ᫮ ᥩ
   int lHeader;  //  
                 // = sizeof(struct VocHeader) + strlen(name)+1+strlen(Comment)+1+sizeof(UserdefinedData)

// ᯮ짮 ᦠ⨥ - / - 1/0
//  bdx  wrd 䠩 ᯮ ᦠ⨥ ᥩ  ,
//  dat - ᦠ⨥   - ᫮ 
   int usecompression;  //
//  ᯮ짮 usecompression
//  bdx -  ⮫쪮 2-3-4  pos
//  wrd - p  ᫮ p 祭 0-31 砥 p p 2-33 p   p饣 ᫮

   time_t CreationTime;   // ६ ᮧ
   time_t LastchangeTime; // ६ ᫥ 䨪樨
   char LocaleName[16];   //   ( ᯨ᪠ ᫮),  ன ᮧ ᫮ (for example "RU_RU"  "RU_RU.IBM-866")
   char LocaleNameArticle[16];  //    ᫮୮ ,  ன ᮧ ᫮ (for example "RU_RU"  "RU_RU.IBM-866")

//   ਩  ࠧ  䨪஢    ࠧ஬ sizeof(struct VocHeader)
   int lName;           //    㫥
   int lComment;       //     㫥
};


//   ⤥쭮 ᫮
class VocabIndex
{
 public:
   int       pos;   //  ᫮୮  ⭮⥫쭮 砫 䠩 
   short int l;     //  ᫮୮ 
   short int attr;  // ਡ: 0 - ᫮, 1 - ᫮⠭
   char *    word;  // ᫮  ࠧ/᫮⠭
};


// ⤥ ᫮p
class Vocab
{
 public:
  char fname[VD_MAXPATH];  //   䠩 ᫮
  char name [VD_MAXPATH];  //  ᫮
  char comment[VD_MAXPATH];// ਩
  time_t CreationTime;     // ६ ᮧ
  time_t LastchangeTime;   // ६ ᫥ 䨪樨

  int  n;                  // ᫮ ᫮  ᫮⠭  ᫮
  VocabIndex *index;       // ᨢ  n
  char *Worddata;          // pp뢭    p饭 n ᫮
  int  lenWorddata;        //   뢭   ࠧ饭 ᫮
  int  Error;              // =0 -  訡
  int  Busy;               // =1 - 䫠  (⠭  ன ᫮ -Add/Delete)
  char Locale[16];         //   ᯨ᪠ ᫮,  ன ᫮p p⠥
  char LocaleArticle[16];  //    ᫮୮ 

  Vocab(void)
  { n = 0;
    index = NULL;
    Worddata = NULL;
    lenWorddata = 0;
    name[0] = 0;
    comment[0] = 0;
    Locale[0] = 0;
    LocaleArticle[0]=0;
    Error = 0;
    Busy = 0;
  }

  Vocab(char *_fname);

  ~Vocab()
   {
//     printf("~Vocab call\n");
     if(Worddata != NULL)
                free(Worddata);
     if(index != NULL)
                delete [] index;

   };
// ஢  ⥪⮢ 䠩  p Nike Korolev
  int Import (char *fImport, char *_fname, char *VocName, char *VocComment);
//஢  ⥪⮢ ଠ Slowo
  int Import0(char *fImport, char *_fname, char *VocName, char *VocComment);

// ⥪⮢ ଠ <word><separator><article><endofstring>
  int Import1(char *fImport, char *_fname, char *VocName, char *VocComment, char * separator);

  int fprintfIndex(char *filename); //⫠ 뢮  䠩
  int SortIndex(void);              // ஢ 

//  ᫮  pp㥬 ⥪⮢ p⠢
  int WriteImport(char *fnameFrom, char *_fnameto);
//   䠩 ᫮ -  type=0/1/2 - bdx/wrd/dat
  int WriteVocHeader(FILE *fp, int type, int compression, char *VocName, char *VocComment);
//  ᫮
  int WriteIndex(char *_fnameto);
//⥭ 
  int ReadIndex(char *_fnamefrom);
// ᯨ᪠ ᫮
  int WriteWords(char *_fnameto);
//⥭ ᯨ᪠ ᫮
  int ReadWords(char *_fnamefrom);

// ⥭  䠩 ᫮
  int ReadVocHeader(FILE *fp, int type, int &usecompression, char *VocName, char *VocComment);

//     ᫮ ᫮, 頥 -  ᫮
  int Search(char *word);
//  ⥪ ᫮୮    article   int buflen  ᫮  ᮬ ind
  int GetArticle(int ind, char *article, int buflen);
/*    ᫮  p --// -- */
/* 頥 , 訡 -  Error */
  int GetArticle(char *word, char *article, int buflen);
/*  ᫮  ᫮୮ 쥩 */
   int Add(char *word, char *article);
/* 㤠 ᫮ ind */
   int Delete(int ind);
/*  ᫮ ( ।⥫쭮 ஢) */
   int Save(void);

// ⥬-ᨬ ॠ
// 쭮-㡮 ॠ
   int WaitBusy(void); //   busy
   int SetBusy(void);      // ⠭ busy
   int ReleaseBusy(void);  // ⨥ busy

   int SetLocale(void);    //⠭  ᫮
};

class Dict
{

  public:
  Dict(){};
  ~Dict(){};


};
/* ⠭  ᫮ */
char * SlovarSetLocale(char *Locale);

/* 㭪 ࠢ class VocabIndex */
/* ᯮ  p strcoll  */
/*  뢠 '-'  p 樨  '|' */
int _Optlink VocabSortCmp(const void* s1, const void* s2);

/* p p  宦       */
/* p頥  p 離  pﭨ  p */
/* ᯮ  p toupper  */
int vb_Strcmp(char* s0, char* s1);

////////////////////////////////////////////////////
#if POKA
#include "tworddata.h"
#include "objects.h"
#include "files.h"
#include "expand.h"



class vocab{
    BinDataFile binindex;
    DataFile data;
    WordFile wordindex;
    vocab_header header;

    TExpander expander;
    TWordDataList cache;
    TWordList wordcache;
    TWordList shortlist;

    char* allowed_chars;
    char* upper_chars;
    char dic_fname[1024];

    long int _current, cache_first;
    char toupper(char c) {return upper_chars[c];};
    void fillcache(long int pos);
    int  in_letters(char c) { return (allowed_chars[toupper(c)]==0)?0:1;};
    int cachesize;
    String last;

 public:
    vocab(char* language, char* dir, long int cache_size);
    ~vocab() {;};
    void getlist(TWordList& list, long int pos, long int count);
    String& getword(String& str, long int pos){ wordindex.get(str,binindex.get(pos));return str;};
    long int count() {return header.words_count;};
    void translation(String& s,long int pos) {data.get(s,binindex.get(pos));};
    long int current() {return _current;};
    vocab_header& getheader() {return header;};
    String& expand(String& str) {expander.expand(str);return str;};
    String& check(String& str);
    int  first_letter(String& s);
    String& strtoupper(String& str);
    long int search(String& str1);
    long int score(String& str);
};

#endif

#endif
